local ffi = require 'ffi'
local lj_include = require 'lj_include'

ffi.cdef[[
struct sigstack {
    void *ss_sp;
    int ss_onstack;
};
enum {
    SS_ONSTACK = 1,
    SS_DISABLE
};
typedef struct sigaltstack {
    void *ss_sp;
    int ss_flags;
    size_t ss_size;
} stack_t;
]]

local defs = {
    MINSIGSTKSZ = '2048',
    SIGSTKSZ = '8192',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

