local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('sys_socket')

ffi.cdef[[
struct ifaddrs {
    struct ifaddrs *ifa_next;
    char *ifa_name;
    unsigned int ifa_flags;
    struct sockaddr *ifa_addr;
    struct sockaddr *ifa_netmask;
    union {
	struct sockaddr *ifu_broadaddr;
	struct sockaddr *ifu_dstaddr;
    } ifa_ifu;
    void *ifa_data;
};
int getifaddrs(struct ifaddrs **__ifap);
void freeifaddrs(struct ifaddrs *__ifa);
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

