--[[
	Template for the sxr format.
	Used as basis for every sxr created.
--]]


local json_f = {	
	_supported_categories = {}
	,description = ""

	--Always set
	,collect = true
	,data_type = "sequential_float32"
	,is_logical = false
	,prerun_balance = { mode="interactive_only" ,offset=0 ,target_value=0}
	--============

	,electrical_units = ""
	,output_units = ""
	,source_physical_units = ""
	,sensor_input = {}
	--,_category_specific = {}
	,calibration = {
						{ 
							purpose="sensor_scaling" 
							,mode="" 
							,units=""
						}
						,{ 
							purpose="rezero" 
							,mode="defined_slope_intercept" 
							,slope=1 
							,intercept=0
						}
						,{ 
							purpose="units_conversion" 
							,mode="defined_slope_intercept" 
							,slope=1 
							,intercept=0
							,units=""
						}	
					}

	,database_sensor={
						source_version = ""			--SELF_VERSION
						--this category also contains the fields
						--listed below in "rows"
					}
}

--possible database_sensor rows
local rows = {
	name='Description'
	,id='TID'
	,manufacturer='Manufacturer'
	,serial_number="SNR"
	,location="Store"
	,type='Type'
	,calibration_date='CalDate'
	,calibration_period='CalExpiration'
	,calibration_initials='CalInitials'
	,comment='Comment'
	,descriptor_field='Descriptor'
	,range='Range'
--	,transducer_power='ActiveSupplyVoltage'

	,'calibration'
	,'output_units'
	,'source_physical_units'
	,'sensor_input'
	,'transducer_input'
	,'bridge_resistance'
	,'bridge_lead_wire_resistance'
	,'sensor_input'
	,'_category_specific'
}



local function db_row_setup( sxr_db_row ,sxr_row ,sdbx_row)
	for k,v in pairs( rows) do
		if k == 'range' then
			local range = sdbx_row.Range
			if range > 0 then
				sxr_db_row.range_max = range
				sxr_db_row.range_min = -1 * range
				sxr_row.range_max = range
				sxr_row.range_min = -1 * range
			else
				sxr_db_row.range_max = 100
				sxr_db_row.range_min = -100
				sxr_row.range_max = 100
				sxr_row.range_min = -100
			end

		elseif type(k) == 'number' then
			sxr_db_row[ v] = sxr_row[ v]

		else
			sxr_db_row[ k] = sdbx_row[ v]
		end
	end
end

	
return { json_f=json_f ,db_row_setup=db_row_setup}
