local m = {}

function m:template_init(escaper)
    self.escaper = escaper or (function(str) return str end)
end

local function lookup(key, values_list)
    for _, values in ipairs(values_list) do
        local v = values[key]
        if v ~= nil then
            return v
        end
    end
end

function m:template(template, ...)
    local values_list = {...}
    return template:gsub("%(=([%w_%.']+)=%)",
        function(match)
            local v = lookup(match, values_list)
            if v ~= nil then
                return self.escaper(tostring(v))
            end
            error(string.format("template error, no value for '%s'", match))
        end)
end

return m
